/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  @(#) $Id: start.S 955 2012-10-30 07:31:22Z ertl-honda $
 */

/*
 *   ͥѤΥȥåץ⥸塼(ARM)
 */
#define    TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */
#include "kernel_impl.h"
#include "target_asm.inc"

/*
 *  ƱѤΥޥåʥС
 */
#define MAGIC_START 0x87654321

    ATEXT
    AALIGN(2)
    AGLOBAL(start)
ALABEL(start)
    /*
     *  ץå⡼ɤν
     *  ѡХ⡼ɡFIQ/IRQػ
     */
    msr  cpsr_cxsf, #(CPSR_SVC AOR CPSR_INTLOCK)

    /*
     *  åݥ󥿤ȡե졼ݥ󥿤ν
     *  sl(å¥쥸r10)ꤹɬפ뤫?
     *  gccϥǥեȤǤ-mapcsʤΤɬפʤ
     */
    my_istkpt sp, r0   /* FMP */
    mov  fp, #0        /* ARM⡼ѥե졼ݥ(r11) */
    mov  r7, #0        /* Thumb⡼ѥե졼ݥ    */

    /*
     *  hardware_init_hookθƤӽФ 0Ǥʤ
     *
     *  åȥϡɥ˰¸ɬפʽ
     *  ϡhardware_init_hook ȤؿѰդ
     */
    ldr   r0, =hardware_init_hook
    cmp   r0, #0x00
    movne lr, pc
    bxne  r0

    /*
     *  ޥץåʳϽԤ
     */
    my_core_index r0
    cmp  r0, #(TOPPERS_MASTER_PRCID - 1)
    bne  slave_wait

    /*
     *  ޥץåѿ
     */
    ldr  r0, =start_sync
    mov  r1, #0
    str  r1,[r0]

#ifndef TOPPERS_OMIT_BSS_INIT
    /*
     *  bssΥꥢ
     */
ALABEL(start_1)
    ldr  r1, =BSS_START
    ldr  r2, =BSS_END
    cmp  r1,r2
    bhs  start_3
    mov  r0,#0
ALABEL(start_2)
    str  r0,[r1],#4
    cmp  r1, r2
    blo  start_2
#endif /* TOPPERS_OMIT_BSS_INIT */

ALABEL(start_3)
#ifndef TOPPERS_OMIT_DATA_INIT
    /*
     *  dataν(ROMб)
     *  IDATA_START  IDATA_END ޤǤDATA_START ʹߤ
     *  ԡ
     */
    ldr  r1, =IDATA_START
    ldr  r3, =IDATA_END
    cmp  r1, r3
    bhs  start_5
    ldr  r2, =DATA_START
ALABEL(start_4)
    ldr  r0, [r1],#4
    str  r0, [r2],#4
    cmp  r1, r3
    blo  start_4
#endif /* TOPPERS_OMIT_DATA_INIT */

    /*
     *  software_init_hook ƽФ0 Ǥʤ
     *
     *  եȥĶä˥饤֥ˤ˰¸ɬפʽ
     *  ϡsoftware_init_hook ȤؿѰդ
     *  褤
     */
ALABEL(start_5)
    ldr   r0, =software_init_hook
    cmp   r0, #0x00
    movne lr, pc
    bxne  r0

    /*
     *  target_mprc_initialize θƤӽФ
     *
     *  sta_ker ˥ޥץåΤߤǹԤɬפΤ¹
     */
ALABEL(start_6)
    bl   target_mprc_initialize

    /*
     *  ͥư
     */
ALABEL(start_7)
    ldr  r0, =start_sync
    ldr  r1, =MAGIC_START
    mov  r2, #0
ALABEL(start_8)
    str  r1, [r0, r2]
    add  r2, r2, #4
    cmp  r2, #(TNUM_PRCID * 4)
    bne  start_8

    /* ޥץåѤstart_sync */
    my_core_index r1
    str  r2, [r0, r1, lsl #2]
    bl   sta_ker

    /*
     *  ޥץåʳνԤ롼
     */
ALABEL(slave_wait)
    my_core_index r0
    ldr  r1, =start_sync
ALABEL(slave_wait_1)
    ldr  r2, =MAGIC_START
    ldr  r3, [r1, r0, lsl #2]
    cmp  r3, r2
    bne  slave_wait_1
    mov  r4, #0
    str  r4, [r1, r0, lsl #2]
    bl   sta_ker
